function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
import React from 'react';
import { EditorView } from '@codemirror/view';
import { Compartment } from '@codemirror/state';
import { useCodeMirror } from '@ui-schema/kit-codemirror/useCodeMirror';
import { useEditorClasses } from '@ui-schema/kit-codemirror/useEditorClasses';
export const CodeMirror = ({
  classNamesContent,
  onChange,
  onViewLifecycle,
  onExternalChange,
  value = '',
  extensions,
  effects,
  ...props
}) => {
  const containerRef = React.useRef(null);
  const editorAttributesCompartment = React.useRef(new Compartment());
  const extensionsAll = React.useMemo(() => [editorAttributesCompartment.current.of(EditorView.editorAttributes.of({})), ...(extensions || [])], [extensions]);
  const editor = useCodeMirror(onChange, value, extensionsAll, effects, containerRef, onExternalChange, onViewLifecycle);
  useEditorClasses(editorAttributesCompartment.current, editor, classNamesContent);
  return React.createElement("div", _extends({
    ref: containerRef
  }, props));
};